package fri.util.javascript;

import java.awt.Desktop;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import com.gargoylesoftware.htmlunit.BrowserVersion;

import fri.util.javascript.bom.ConsoleMock;

/**
 * Runs bomTest.js via HtmlUnit and generates a call statistic of the test.
 * 
 * @author Fritz Ritzberger Sep 24, 2014
 */
public class BomTestRunner extends JavaScriptRhinoRunnerWithHtmlUnit
{
	public static void main(String [] args) throws Exception {
		final BomTestPrintStream stream = new BomTestPrintStream(ConsoleMock.stream);
		ConsoleMock.stream = stream;
		
		//final String webPage = "file:///media/windows/fri/eclipse-workspace8/javascript/test.html";
		final String webPage = "http://www.this-page-intentionally-left-blank.org/";
		
		//final String jScript = "/media/windows/fri/eclipse-workspace8/javascript/bomTest.js";
		final String jScript = "bomTest.js";
		
		new ArgumentRunner(new String [] { webPage, jScript }).run(
			new ArgumentRunner.JavaScriptRunnerFactory() {
				public JavaScriptRunner newJavaScriptRunner(String webPage, BrowserVersion browserVersion)	{
					stream.setBrowserVersion(browserVersion.toString());
					return new BomTestRunner(webPage, browserVersion);
				}
			}
		);
		
		dump(stream.getResultAsHtml(JavaScriptRunner.class.getResource(jScript)));
	}
	
	private static void dump(String html) throws IOException {
		if (Desktop.isDesktopSupported())	{
			final File tempFile = File.createTempFile(BomTestRunner.class.getSimpleName(), ".html");
			final Writer writer = new FileWriter(tempFile);
			writer.write(html, 0, html.length());
			writer.close();
			Desktop.getDesktop().browse(tempFile.toURI());
		}
		else	{
			System.out.println(html);
		}
	}

	public BomTestRunner(String webPage, BrowserVersion browserVersion) {
		super(webPage, browserVersion);
	}
	
	
}
