package fri.util.javascript;

import javax.script.Bindings;

import fri.util.javascript.bom.WindowMock;

/**
 * JavaScript files to read and interpret must be given on commandline in order,
 * either as URL or as absolute file path, e.g.:
 * <pre>
 * java RunJavaScript
 * 		file:///media/windows/fri/eclipse-workspace8/javascript/class.js
 * 		file:///media/windows/fri/eclipse-workspace8/javascript/classTest.js
 * </pre>
 * 
 * @author Fritz Ritzberger Sep 24, 2014
 */
public class JavaScriptRunnerWithBomMocks extends JavaScriptRunner
{
	public static void main(String [] args) throws Exception {
		new JavaScriptRunnerWithBomMocks().execute(args);
	}

	/**
	 * Creates naive BOM mock bindings.
	 */
	protected void addGlobalBindings(Bindings bindings) {
		final WindowMock window = new WindowMock();
		bindings.put("window", window);
		bindings.put("console", window.getConsole());
		bindings.put("document", window.getDocument());
		bindings.put("navigator", window.getNavigator());
		bindings.put("location", window.getLocation());
		bindings.put("history", window.getHistory());
		bindings.put("screen", window.getScreen());
	}

}
