package fri.util.javascript;

import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;

public class ReaderUtil
{
	public static String toString(Reader reader) throws IOException {
		final StringBuilder sb = new StringBuilder();
		try	{
			int c;
			while ((c = reader.read()) != -1)
				sb.append((char) c);
		}
		finally	{
			reader.close();
		}
		return sb.toString();
	}

	public static String toString(String scriptPath) throws IOException {
		return toString(new FileReader(scriptPath));
	}
	
	public static String toString(URL scriptUrl) throws IOException {
		return toString(new InputStreamReader(scriptUrl.openStream()));
	}

}
