package fri.util.javascript.htmlunit;

import java.io.Reader;

import com.gargoylesoftware.htmlunit.BrowserVersion;

import fri.util.javascript.JavaScriptRhinoRunnerWithHtmlUnit;
import fri.util.javascript.JavaScriptRunner;
import fri.util.javascript.ReaderUtil;

/**
 * Run a JavaScript via HtmlUnit <code>webClient.getJavaScriptEngine().execute()</code>.
 * <p/>
 * Amazingly one must initialize the Rhino engine manually when doing this,
 * which is the reason why this class extends <code>JavaScriptRhinoRunnerWithHtmlUnit</code>.
 * 
 * @author Fritz Ritzberger Sep 24, 2014
 */
public class HtmlUnitJavaScriptRunner extends JavaScriptRhinoRunnerWithHtmlUnit
{
	public static void main(String [] args) throws Exception {
		new ArgumentRunner(args).run(
			new ArgumentRunner.JavaScriptRunnerFactory() {
				public JavaScriptRunner newJavaScriptRunner(String webPage, BrowserVersion browserVersion)	{
					return new HtmlUnitJavaScriptRunner(webPage, browserVersion);
				}
			}
		);
	}
	
	public HtmlUnitJavaScriptRunner(String webPage, BrowserVersion browserVersion) {
		super(webPage, browserVersion);
	}
	
	@Override
	protected void execute(Object scriptEngine, Reader reader, String origin)	throws Exception {
		final String scriptText = ReaderUtil.toString(reader);
		webClient.getJavaScriptEngine().execute(page, scriptText, origin, 1);
	}

}
